package prodcons;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;

public class BufferViewer extends JPanel implements Observer {

    private SynchronizedBuffer buffer;
    private JLabel[] labels;
    private SmerVypisu sv = SmerVypisu.ZPRAVA;

    public BufferViewer(SynchronizedBuffer buffer) {
        this.buffer = buffer;
        this.setLayout(new GridLayout(1,buffer.CAPACITY));
        labels = new JLabel[buffer.CAPACITY];
        buffer.addObserver(this);
        for(int i = 0; i < buffer.CAPACITY; i++) {
            labels[i] = new JLabel("");
            labels[i].setOpaque(true);
            labels[i].setHorizontalTextPosition(SwingConstants.CENTER);
            add(labels[i]);
        }
    }

    public void setSmerVypisuBufferu(SmerVypisu smerVypisu) {
        this.sv = smerVypisu;
    }

    @Override
    public void update(Observable o, Object arg) {
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                int[] values = buffer.getValues();
                int i = 0;
                for(; i < buffer.CAPACITY-values.length; i++) {
                    labels[i].setText("");
                    labels[i].setBackground(Color.DARK_GRAY);
                }
                for(i = 0; i < values.length; i++) {
                    int j = i + buffer.CAPACITY-values.length;
                    labels[j].setText(String.format(" %d ", values[getValuesIndex(values.length,i)]));
                    labels[j].setBackground(Color.WHITE);
                }
            }
        });
    }
    private int getValuesIndex(int length,int i) {
        if(sv == SmerVypisu.ZLEVA) {
            return length-1-i;
        }
        return i;
    }

    public static enum SmerVypisu {
       ZLEVA,ZPRAVA;
    }
}